'Detect LabVIEW Run-Time Engine 7.1 and install if needed
'Spectral Products, LLC. (c) 2009 by Nicolas C. Torres  1-8-2009

#COMPILE EXE  '#8.03#
#DIM ALL
#INCLUDE "win32api.inc"

FUNCTION PBMAIN () AS LONG
    LOCAL hKey AS LONG
    LOCAL Result AS LONG
    LOCAL Path AS STRING

    IF RegOpenKeyEx(%HKEY_LOCAL_MACHINE, "Software\National Instruments\LabVIEW Run-Time\7.1", BYVAL %null , _
                     %Key_Read, hKey)<> %Error_Success THEN
        Result = MSGBOX( "LabVIEW RUN-TIME Engine is not installed!" _      'get response from user
          & $CRLF & $CRLF & "You do not need to install the LabVIEW Run-Time Engine 7.1" _
          & $CRLF & "if you have labVIEW 7.1 already installed. You can always install it" _
          & $CRLF & "directly from the CD later." _
          & $CRLF & $CRLF & "Would you like to install it now?" _
            , %MB_YESNO OR %MB_SYSTEMMODAL, "Install Run-Time Engine")
    ELSE
        MSGBOX "You have LabVIEW Run-Time Engine 7.1 installed" _
               , %MB_OK OR %MB_SYSTEMMODAL, "Run-Time Engine 7.1 Detected"
    END IF

    RegCloseKey(hKey)     'close key

    Path = CURDIR$  'get current path
    Path = RTRIM$(Path, "DETECTORS\spAD111_Gpib\SpAD111_DKGpib_Installation")   'go to main root directory
    Path = Path & "LabViewEngine\LabViewRunTimeEng71\LVRunTimeEng71.exe"        'go to directory for executable
    TRY
        IF Result = %IDYES  THEN SHELL Path, 1                                  'install labView Run-time engine
        EXIT TRY
    CATCH
        MSGBOX "Could not find LabView Run-Time Engine 7.1" _
            & $CRLF & $CRLF & "You might be getting this error if you are" _
            & $CRLF & "installing from a different directory. Try" _
            & $CRLF & "installing run-time engine from CD." , %MB_ICONERROR OR %MB_SYSTEMMODAL, "ERROR FINDING PROGRAM"
    END TRY


END FUNCTION
