// DeviceSetupDlg.cpp : implementation file
//

#include "stdafx.h"
#include "abSDK.h"
#include "abSDKDlg.h"
#include "DeviceSetupDlg.h"


#include "abDLLusb.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern unsigned int iModel;
extern unsigned int uiOffset;
extern unsigned int uiDelay;
extern unsigned int uiSerial;
extern unsigned int uiFwVer;
extern int iDevice;
extern int inOvn;


/////////////////////////////////////////////////////////////////////////////
// CDeviceSetupDlg dialog


CDeviceSetupDlg::CDeviceSetupDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDeviceSetupDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDeviceSetupDlg)
	m_ui_Offset = 0;
	m_ui_Delay = 0;
	m_ui_Serial = 0;
	m_DefaultValues = FALSE;
	m_stCommand = _T(" ");
	//}}AFX_DATA_INIT
}


void CDeviceSetupDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDeviceSetupDlg)
	DDX_Control(pDX, IDC_DEVICETYPE, m_cbo_ABType);
	DDX_Control(pDX, IDC_SETUPDEVICE, m_cbo_Device);
	DDX_Text(pDX, IDC_OFFSET, m_ui_Offset);
	DDV_MinMaxUInt(pDX, m_ui_Offset, 0, 65535);
	DDX_Text(pDX, IDC_DELAY, m_ui_Delay);
	DDV_MinMaxUInt(pDX, m_ui_Delay, 0, 65535);
	DDX_Text(pDX, IDC_SERIAL, m_ui_Serial);
	DDX_Check(pDX, IDC_CHKDEFAULT, m_DefaultValues);
	DDX_Text(pDX, IDC_COMMAND, m_stCommand);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDeviceSetupDlg, CDialog)
	//{{AFX_MSG_MAP(CDeviceSetupDlg)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPINZERO, OnDeltaposSpinzero)
	ON_BN_CLICKED(IDC_READFROMEEPROM, OnReadfromeeprom)
	ON_BN_CLICKED(IDC_CHANGEDEVICE, OnChangedevice)
	ON_BN_CLICKED(IDC_WRITETOEEPROM, OnWritetoeeprom)
	ON_BN_CLICKED(IDC_ZERO, OnZero)
	ON_BN_CLICKED(IDC_CHKDEFAULT, OnChkdefault)
	ON_CBN_SELCHANGE(IDC_DEVICETYPE, OnSelchangeDevicetype)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDeviceSetupDlg message handlers

BOOL CDeviceSetupDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	CRect rt;
	// AB300 Type combo box setup
	m_cbo_ABType.GetWindowRect(&rt);
	ScreenToClient(&rt);
	rt.bottom = rt.top + rt.Height()*4;
	m_cbo_ABType.MoveWindow(rt);
	m_cbo_ABType.SetCurSel(sABType);
	// Result Window
	//m_lbResult.GetWindowRect(rt);
	//ScreenToClient(rt);
	//m_lbResult.SetColumnWidth(rt.Width());

	// USB Device combo box setup
	m_cbo_Device.GetWindowRect(&rt);
	ScreenToClient(&rt);
	rt.bottom = rt.top + rt.Height()*4;
	m_cbo_Device.MoveWindow(rt);
	m_cbo_Device.SetCurSel(iDevice);

	inOvn=0;		//0:No, 1:Yes
	//OnBtnDevice();

    Queries();
	UpDateInfo();

	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE


}


short CDeviceSetupDlg::UpDateInfo()
{
	short sRtn;
	sRtn=0;		//0:OK
	
	m_cbo_ABType.SetCurSel(iModel-301);
	m_ui_Offset=uiOffset;
	m_ui_Delay=uiDelay;
	m_ui_Serial=uiSerial;
	//TRUE: update variables
	UpdateData(FALSE);
	return sRtn;
}

short CDeviceSetupDlg::Queries()
{	//0: no error, 4: error occurred
	short sRtn, sRtn2;
	short *sData;
	sData = new short[8];

	sRtn2=0;		//0:OK
	//[0]:Pwr, [1]:Position, [2,3]:Model, [4,5]:Offset, [6,7]:Version
	// Query Command
	sRtn=abQuery(sData);
	//0: no error, 1: Not echo, 2: Port not open; 3: wrong echo; 4: error occurred
	if(sRtn !=0)
	  sRtn2=sRtn;
	else
	{
	  iPower=sData[0];
	  iPos=sData[1];
	  iModel=sData[2]*256+sData[3];
	  uiOffset=sData[4]*256+sData[5];
	  uiFwVer=sData[6]*256+sData[7];
	  FwVer.Format(_T("FW Version: %u.%u"),sData[6],sData[7]);

	  //[0,1]:Model, [2,3]:Offset, [4,5]:Delay, [6,7]:Serial
	  // AB300 Echoed Command
	  sRtn=abRdEeprom(sData);
	  uiSerial=sData[6]*256+sData[7];
	  uiDelay=sData[4]*256+sData[5];

	  if(sRtn !=0)
	    sRtn2=sRtn;
	}
	delete[] sData;
	return sRtn2;
}


void CDeviceSetupDlg::OnDeltaposSpinzero(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here
	
	short sRtn;
	CString strTmp;					//temp string variable

	//iDelta: -1=Up, 1=Dn. 
	switch (pNMUpDown->iDelta)
	{
	  case 1:		//1=Dn
		  // Step Down Command
		  strTmp.Format(_T("StepDn"));
		  sRtn=abStepDn();				//dll call function
		  break;
	  case -1:		//0=Up
		  // Step Up Command
		  strTmp.Format(_T("StepUp"));
		  sRtn=abStepUp();				//dll call function
		  break;
	  default:

	 	  break;
	}
	if(sRtn !=0)
	{
		strTmp.Format(_T("Error Stepping Filter Wheel")); 
	    AfxMessageBox(strTmp,MB_OK);
		return;
	}
	m_stCommand = strTmp;			//send it to static window
	UpdateData(FALSE);				//display
	
	*pResult = 0;
}

void CDeviceSetupDlg::OnReadfromeeprom() 
{
	// read data from EEPROM
	short sRtn;
	CString strTmp;

	// Queries function
	sRtn=Queries();
	//0: no error, 1: Not echo, 2: Port not open; 3: wrong echo; 4: error occurred
	if(sRtn !=0)
	  strTmp.Format(_T("An Error Has Occurred"));
	else
	{
	  m_cbo_ABType.SetCurSel(iModel-301);
	  m_ui_Offset=uiOffset;
	  m_ui_Delay=uiDelay;
	  m_ui_Serial=uiSerial;
	  //TRUE: update variables
	  UpdateData(FALSE);

	  if(sRtn !=0)
	    strTmp.Format(_T("An Error Has Occurred"));
	  else
	    strTmp.Format(_T("'Read' was completed"));

	}
	m_stCommand = strTmp;			//send it to static window
	UpdateData(FALSE);				//display	
}

void CDeviceSetupDlg::OnWritetoeeprom() 
{
	// TODO: Add your control notification handler code here
	short sRtn;
	short *sData;
	CString strTmp;
	sData = new short[8];

	//TRUE: update variables
	UpdateData(TRUE);
	sData[0]=1;
	sData[1]=m_cbo_ABType.GetCurSel() + 45;
	TwoUChar.UInt=m_ui_Offset;
	sData[2]=TwoUChar.UChar[1];		//UChar[1]: HiB
	sData[3]=TwoUChar.UChar[0];

	TwoUChar.UInt=m_ui_Delay;
	sData[4]=TwoUChar.UChar[1];		//UChar[1]: HiB
	sData[5]=TwoUChar.UChar[0];

	TwoUChar.UInt=m_ui_Serial;
	sData[6]=TwoUChar.UChar[1];		//UChar[1]: HiB
	sData[7]=TwoUChar.UChar[0];


	//[0,1]:Model, [2,3]:Offset, [4,5]:Delay, [6,7]:Serial
	// Eeprom Write Command
	sRtn=abWrEeprom(sData);
	
	if(sRtn !=0)
	  strTmp.Format(_T("An Error Has Occurred"));
	else
	  strTmp.Format(_T("'Write' was completed"));
//	m_lbResult.AddString(strTmp);
	m_stCommand = strTmp;			//send it to static window
	UpdateData(FALSE);				//display	

	delete[] sData;	
}


void CDeviceSetupDlg::OnZero() 
{
	// TODO: Add your control notification handler code here
	short sRtn;
	CString strTmp;
	// Step Up Command
	sRtn=abZero();
	if(sRtn !=0)
	  strTmp.Format(_T("An Error Has Occurred"));
	else
	  strTmp.Format(_T("ZEROed "));
//	m_lbResult.AddString(strTmp);	
	m_stCommand = strTmp;			//send it to static window
	UpdateData(FALSE);				//display
}



void CDeviceSetupDlg::OnChangedevice() 
{
	// TODO: Add your control notification handler code here
		CString strTmp;
	short sRtn;			//5: OutOfRange
	int iDeviceNew;

	if(inOvn==1)		//0:No, 1:Yes
	{
	  strTmp.Format(_T("STOP the Test First "));
	  AfxMessageBox(strTmp);
	  return;
	}
	iDeviceNew= iDevice;
	m_dDevice.DoModal();
	m_cbo_Device.SetCurSel(iDevice);
	//TRUE: update variables
	UpdateData(TRUE);

	if (iDeviceNew==iDevice)
	{}
	else
	{
	  sRtn=abDevice(iDevice);
	  switch (sRtn)
	  {
		case 0:
		  Queries();
		  UpDateInfo();
		  strTmp.Format(_T("Current Device : %u"),iDevice);
		  break;
		case 2:
		  strTmp.Format(_T("Can't Open the Device %u."),iDevice);
		  iDevice= iDeviceNew;
		  m_cbo_Device.SetCurSel(iDevice);
		  //TRUE: update variables
		  UpdateData(TRUE);
		  break;
		case 5:
		  strTmp.Format(_T("Device %u is out of range."),iDevice);
		  iDevice= iDeviceNew;
		  m_cbo_Device.SetCurSel(iDevice);
		  //TRUE: update variables
		  UpdateData(TRUE);
		  break;
		default:
		  strTmp.Format(_T("Error has occurred"));			  
		  break;
	  }
	  //m_lbResult.AddString(strTmp);
	m_stCommand = strTmp;			//send it to static window
	UpdateData(FALSE);				//display
	}
	
}

void CDeviceSetupDlg::OnChkdefault() 
{
	// TODO: Add your control notification handler code here
	if (m_DefaultValues == TRUE) m_DefaultValues = FALSE;
	if (m_DefaultValues == FALSE) m_DefaultValues = TRUE;
	
}



void CDeviceSetupDlg::OnSelchangeDevicetype() 
{
	// TODO: Add your control notification handler code here
	//if check box is checked set default values
	 
	if (m_DefaultValues == TRUE)
	{
		//load default values
		if (m_cbo_ABType.GetCurSel() == 0)		//AB301
		{
			iModel = 0;
			uiOffset = 32862;
			uiDelay = 500;
		}
		if (m_cbo_ABType.GetCurSel() == 1)		//AB302
		{
			iModel = 0;
			uiOffset = 32977;
			uiDelay = 500;
		}
		if (m_cbo_ABType.GetCurSel() == 2)		//AB303
		{
			iModel = 0;
			uiOffset = 32825;
			uiDelay = 500;
		}
		if (m_cbo_ABType.GetCurSel() == 3)		//AB304
		{
			iModel = 0;
			uiOffset = 32907;
			uiDelay = 500;
		}

		UpDateInfo();					//Refresh data
	}

	
}
