// abUSB.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"

#define	__AB300__
#include "abUSB.h"
#undef	__AB300__

/////////////////////////////////////
BOOL bOpenDriver (PCHAR devname);
void BuldIO( int SndRcv );

HANDLE ghDevice = NULL;
//char* pcDriverName="2ab3s-0";
char pcDriverName[]="2ab3s-0";

/////////////////////////////////////


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


// *******************************
#define MAX_DRIVER_NAME 64
#define DEVICE_DESCRIPTOR_SIZE 32 /* bigger than we need */
#define MAX_ITEMS_IN_LB 1024
#define MAX_BUFFER_SIZE 512
// *******************************

///////////////////////////////////////////////////////

enum {
	ONE = 0,
	TWO = 1,
	THREE = 2,
	FOUR = 3,
	FINAL = 9
};

enum {	// For TE Cooler Setting
	OFF = 0,
	ON = 1
};


//
//	Note!
//
//		If this DLL is dynamically linked against the MFC
//		DLLs, any functions exported from this DLL which
//		call into MFC must have the AFX_MANAGE_STATE macro
//		added at the very beginning of the function.
//
//		For example:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//			// normal function body here
//		}
//
//		It is very important that this macro appear in each
//		function, prior to any calls into MFC.  This means that
//		it must appear as the first statement within the 
//		function, even before any object variable declarations
//		as their constructors may generate calls into the MFC
//		DLL.
//
//		Please see MFC Technical Notes 33 and 58 for additional
//		details.
//

/////////////////////////////////////////////////////////////////////////////
// CAbUSBApp

BEGIN_MESSAGE_MAP(CAbUSBApp, CWinApp)
	//{{AFX_MSG_MAP(CAbUSBApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAbUSBApp construction

CAbUSBApp::CAbUSBApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CAbUSBApp object

CAbUSBApp theApp;


/**************************************************
 *                                                *
 * USB                                            *
 *                                                *
 **************************************************/

/**************************************************
 * bOpenDriver proc                               *
 *                                                *
 * Purpose:                                       *  
 *      Opens the device driver using symbolic    *
 *      name provided                             *
 *                                                *
 * Input:                                         *
 *      phDeviceHandle:                           *
 *          Pointer to Device Driver handle where *
 *          the file handle is placed.            *
 *      devname:                                  *
 *          Null terminated string containing the *
 *          device name                           *
 *                                                *
 * Return Value:                                  *
 *      Boolean that indicates if the driver was  *
 *      successfully opened or not.               *
 *                                                *
 **************************************************/

BOOL bOpenDriver (PCHAR devname)
{
    char completeDeviceName[64] = "";

    strcat (completeDeviceName,"\\\\.\\");
    strcat (completeDeviceName,devname);

    ghDevice = CreateFile(   completeDeviceName,
		                            GENERIC_WRITE,
		                            FILE_SHARE_WRITE,
		                            NULL,
		                            OPEN_EXISTING,
		                            0,
		                            NULL);

    if (ghDevice == INVALID_HANDLE_VALUE)  return (FALSE);
    return (TRUE);
}

int BulkO(int cmdO, long dataO, int lenO)
{	// Command to the USB board.  Return 0: Failed to open the driver, 1: OK
	union
	{
		unsigned int UInt[2];
		unsigned long ULong;
		unsigned char UChar[4];
	} FourUChar;

	FourUChar.ULong=dataO;

	UCHAR outBuffer[64];			//buffer for bulk out and bulk in
	WORD outPacketSize = lenO;
	BULK_TRANSFER_CONTROL bulkControl;
	BOOL ERRORS = FALSE;
	BOOL bget = FALSE; 
	int nBytes = 0;		//1;
	int i=0;  //pipe number write	0
	int j=2;  //pipe number read	7


	// Open the driver
	if (bOpenDriver (pcDriverName) != TRUE){
		ghDevice = NULL;
		AfxMessageBox(_T("Failed to open the USB driver.  Please check the USB connection status."));
		return 0;
	}

	bulkControl.pipeNum = i; //use pipe 0

	outBuffer[0]= cmdO;

	switch (lenO)
	{
		case 2:
			outBuffer[1]= FourUChar.UChar[0];
			break;
		case 3:
			outBuffer[1]= FourUChar.UChar[1];
			outBuffer[2]= FourUChar.UChar[0];
			break;
		case 4:
		default:
			outBuffer[1]= FourUChar.UChar[0];
			outBuffer[2]= FourUChar.UChar[1];
			outBuffer[3]= FourUChar.UChar[2];
			outBuffer[4]= FourUChar.UChar[3];
			break;
	}


	//perform the BULK OUT
	bget= DeviceIoControl (ghDevice,
		IOCTL_EZUSB_BULK_WRITE,
		&bulkControl,
		sizeof(BULK_TRANSFER_CONTROL),
		&outBuffer[0],
		outPacketSize,
		(unsigned long *) &nBytes,
		NULL);

	if(bget == FALSE){
		DWORD dwError = GetLastError();
		CString strError;
		strError.Format(_T("Error code = %d"), dwError);
		AfxMessageBox(strError);

		CloseHandle (ghDevice);
		return 0;		
	}

	CloseHandle (ghDevice);
	
	return 1;
}


int BulkOArray(int cmdO, short *dataO, int lenO)
{	// Command to the USB board.  Return 0: Failed to open the driver, 1: OK

	UCHAR outBuffer[64];			//buffer for bulk out and bulk in
	WORD outPacketSize = lenO;
	BULK_TRANSFER_CONTROL bulkControl;
	BOOL ERRORS = FALSE;
	BOOL bget = FALSE; 
	int nBytes = 0;		//1;
	int i=0;  //pipe number write	0
	int j=2;  //pipe number read	7


	// Open the driver
	if (bOpenDriver (pcDriverName) != TRUE){
		ghDevice = NULL;
		AfxMessageBox(_T("Failed to open the USB driver.  Please check the USB connection status."));
		return 0;
	}

	bulkControl.pipeNum = i; //use pipe 0

	outBuffer[0]= cmdO;

	for(int k=0 ; k<lenO ; k++)
		outBuffer[k+1] = (UCHAR) dataO[k];

	//perform the BULK OUT
	bget= DeviceIoControl (ghDevice,
		IOCTL_EZUSB_BULK_WRITE,
		&bulkControl,
		sizeof(BULK_TRANSFER_CONTROL),
		&outBuffer[0],
		outPacketSize,
		(unsigned long *) &nBytes,
		NULL);

	if(bget == FALSE){
		DWORD dwError = GetLastError();
		CString strError;
		strError.Format(_T("Error code = %d"), dwError);
		AfxMessageBox(strError);

		CloseHandle (ghDevice);
		return 0;		
	}

	CloseHandle (ghDevice);
	
	return 1;
}


int BulkI( UCHAR* inBuffer, int lenI )
{	// Command from the USB board
	WORD inPacketSize = lenI; 
	BULK_TRANSFER_CONTROL bulkControl;
	BOOL ERRORS = FALSE;
	BOOL bget = FALSE; 
	int nBytes = 0;
	int i=0;  //pipe number write	0
	int j=2;  //pipe number read	7

	
	// Open the driver
	if (bOpenDriver (pcDriverName) != TRUE){
		ghDevice = NULL;
		AfxMessageBox(_T("Failed to open the USB driver.  Please check the USB connection status."));
		return 0;
	}
	
	bulkControl.pipeNum = j;
	//perform BULK IN
	bget= DeviceIoControl (ghDevice,
		IOCTL_EZUSB_BULK_READ,
		&bulkControl,
		sizeof(BULK_TRANSFER_CONTROL),
		&inBuffer[0],
		inPacketSize,
		(unsigned long *) &nBytes,
		NULL);

	if(bget == FALSE){
		DWORD dwError = GetLastError();
		CString strError;
		strError.Format(_T("Error code = %d"), dwError);
		AfxMessageBox(strError);

		CloseHandle (ghDevice);
		return 0;		
	}

	CloseHandle (ghDevice);		

	return 1;
}

int BulkRunCheck(char cBuffer)
{	// Checking function after running BulkI and BulkO
	switch(cBuffer){
	case 13:
		AfxMessageBox(_T("Error!!! The board doesn't work correctly!"));
		return -1;
		break;
	case 17:
		AfxMessageBox(_T("Invalid!!! The current board doesn't support this function.  Please check the manual."));
		return -2;
		break;
	}

	return 1;
}

int CvtLongToChar4(unsigned long lInp, unsigned char *ucOut)
{	// Converting from 4 char to long

	ucOut[ONE] = (unsigned char)(lInp >> 24);
	if(ucOut[ONE])	lInp -= ucOut[ONE] * 16777216;	// 24 bit

	ucOut[TWO] = (unsigned char)(lInp >> 16);
	if(ucOut[TWO])	lInp -= ucOut[TWO] * 65536;	// 16 bit

	ucOut[THREE] = (unsigned char)(lInp >> 8);
	if(ucOut[THREE])	lInp -= ucOut[THREE] * 256;	// 8 bit

	ucOut[FOUR] = (unsigned char)lInp;

	// Swap
	unsigned char ucTmp;
	ucTmp = ucOut[ONE];	ucOut[ONE] = ucOut[FOUR];	ucOut[FOUR] = ucTmp;
	ucTmp = ucOut[TWO];	ucOut[TWO] = ucOut[THREE];	ucOut[THREE] = ucTmp;

	return 1;
}

unsigned long CvtChar4ToLong(unsigned char *cInp)
{	// Converting from long to 4 char
	unsigned long lRst;
	lRst = cInp[ONE] * 16777216 + cInp[TWO] * 65536 + cInp[THREE] * 256 + cInp[FOUR];

	return lRst;
}

void sleep(long lMilliSec)
{
	long goal;
	goal = lMilliSec + clock();
	while( goal > clock());
}


///////////////////////// DLL Export Functions //////////////////////////////////////////////
DLLEXPORT short CALLTYPE abEcho(short sByte, short *sEcho)
{	//0: no error, 1: Not echo, 2: Port not open; 3: wrong echo; 4: error occurred  
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	unsigned char ucBuffer;
	int nRtn;

	// Echo Command
	nRtn = BulkO(1, (long) sByte, 2);
	if(nRtn == 0){	return 4; }	// Something wrong...
	nRtn = BulkI(&ucBuffer, 1);
	if(nRtn == 0){	return 4; }	// Something wrong...
	if(BulkRunCheck(ucBuffer) < 0)	return 4;	// Bulk function run check
    *sEcho = ucBuffer;
	return 0;
}

DLLEXPORT short CALLTYPE abQuery(short *sQueryB)
{	//0: no error, 1: Not echo, 2: Port not open; 3: wrong echo; 4: error occurred  
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	unsigned char *ucBuffer;
	ucBuffer = new unsigned char [10];

	// Query Command
	BulkO(5, 0, 1);
	BulkI(ucBuffer, 13);
	if(BulkRunCheck(ucBuffer[ONE]) < 0)
	{	// Bulk function run check
		delete[] ucBuffer;
		return 4;
	}

	for(int i=0 ; i<8 ; i++)
		sQueryB[i] = (short)ucBuffer[i];

	delete[] ucBuffer;
	return 0;
}

DLLEXPORT short CALLTYPE abReset()
{	//0: no error, 1: Not echo, 2: Port not open; 3: wrong echo; 4: error occurred  
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	unsigned char ucBuffer;
	int nRtn;

	// Reset Command
	nRtn = BulkO(6, 0, 1);
	if(nRtn == 0){	return 4; }	// Something wrong...
	nRtn = BulkI(&ucBuffer, 1);
	if(nRtn == 0){	return 4; }	// Something wrong...
	if(BulkRunCheck(ucBuffer) < 0)	return 4;	// Bulk function run check
    return 0;
}

DLLEXPORT short CALLTYPE abZero()
{	//0: no error, 1: Not echo, 2: Port not open; 3: wrong echo; 4: error occurred  
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	unsigned char ucBuffer;
	int nRtn;

	// Zero Command
	nRtn = BulkO(9, 0, 1);
	if(nRtn == 0){	return 4; }	// Something wrong...
	nRtn = BulkI(&ucBuffer, 1);
	if(nRtn == 0){	return 4; }	// Something wrong...
	if(BulkRunCheck(ucBuffer) < 0)	return 4;	// Bulk function run check
    return 0;
}

DLLEXPORT short CALLTYPE abStepDn()
{	//0: no error, 1: Not echo, 2: Port not open; 3: wrong echo; 4: error occurred  
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	unsigned char ucBuffer;
	int nRtn;

	// StepDown Command
	nRtn = BulkO(7, 0, 1);
	if(nRtn == 0){	return 4; }	// Something wrong...
	nRtn = BulkI(&ucBuffer, 1);
	if(nRtn == 0){	return 4; }	// Something wrong...
	if(BulkRunCheck(ucBuffer) < 0)	return 4;	// Bulk function run check
    return 0;
}

DLLEXPORT short CALLTYPE abStepUp()
{	//0: no error, 1: Not echo, 2: Port not open; 3: wrong echo; 4: error occurred  
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	unsigned char ucBuffer;
	int nRtn;

	// StepUp Command
	nRtn = BulkO(8, 0, 1);
	if(nRtn == 0){	return 4; }	// Something wrong...
	nRtn = BulkI(&ucBuffer, 1);
	if(nRtn == 0){	return 4; }	// Something wrong...
	if(BulkRunCheck(ucBuffer) < 0)	return 4;	// Bulk function run check
    return 0;
}

DLLEXPORT short CALLTYPE abGoto(short sFilterN)
{	//0: no error, 1: Not echo, 2: Port not open; 3: wrong echo; 4: error occurred  
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	unsigned char ucBuffer;
	int nRtn;

	// Goto Command
	nRtn = BulkO(4, (long) sFilterN, 2);
	if(nRtn == 0){	return 4; }	// Something wrong...
	nRtn = BulkI(&ucBuffer, 1);
	if(nRtn == 0){	return 4; }	// Something wrong...
	if(BulkRunCheck(ucBuffer) < 0)	return 4;	// Bulk function run check
	return 0;
}

DLLEXPORT short CALLTYPE abWrEeprom(short *sEepromB)
{	//0: no error, 1: Not echo, 2: Port not open; 3: wrong echo; 4: error occurred  
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	unsigned char *ucBuffer;
	ucBuffer = new unsigned char [10];

	for(int i=0 ; i<9 ; i++)
		ucBuffer[i] = (UCHAR) sEepromB[i];

	// Setup Command
	BulkOArray(3, sEepromB, 9);
	BulkI(ucBuffer, 1);
	if(BulkRunCheck(ucBuffer[ONE]) < 0)
	{	// Bulk function run check
		delete[] ucBuffer;
		return 4;
	}
	delete[] ucBuffer;
	return 0;
}


DLLEXPORT short CALLTYPE abRdEeprom(short *sEepromB)
{	//0: no error, 1: Not echo, 2: Port not open; 3: wrong echo; 4: error occurred  
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	unsigned char *ucBuffer;
	ucBuffer = new unsigned char [10];

	// Read Eeprom Command
	BulkO(2, 0, 1);
	BulkI(ucBuffer, 8);
	if(BulkRunCheck(ucBuffer[ONE]) < 0)
	{	// Bulk function run check
		delete[] ucBuffer;
		return 4;
	}

	for(int i=0 ; i<8 ; i++)
		sEepromB[i] = (short)ucBuffer[i];

	delete[] ucBuffer;
	return 0;
}


DLLEXPORT short CALLTYPE abDevice(short sDevice)
{	//0: no error, 2: Port not open; 3: wrong echo; 4: error occurred; 5:OutOfRange
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	//sDevice from 0 to 63

	short nRtn;
	int c;
	nRtn=0;		//0:OK

	if (sDevice>64)
	{
		nRtn=5;	//5: Out of Range
	}
	else
	{
		c = 0x30+ sDevice;
		pcDriverName[6]=(char)c;
		
		// Open the driver
		if (bOpenDriver (pcDriverName) != TRUE)
		{
		  nRtn=2;	//2: Port not open
		  ghDevice = NULL;
		}
		else
		{
		  nRtn=0;	//0:OK
		  CloseHandle (ghDevice);
		}
	}
	return nRtn;
}

